
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Activity_commentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const activity_comments = await db.activity_comments.create(
            {
                id: data.id || undefined,
        
        visibility: data.visibility
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        posted_at: data.posted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await activity_comments.setTenant( data.tenant || null, {
            transaction,
        });
        
        await activity_comments.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await activity_comments.setAuthor( data.author || null, {
            transaction,
        });
        
        await activity_comments.setBooking_request( data.booking_request || null, {
            transaction,
        });
        
        await activity_comments.setReservation( data.reservation || null, {
            transaction,
        });
        
        await activity_comments.setService_request( data.service_request || null, {
            transaction,
        });
        
        await activity_comments.setInvoice( data.invoice || null, {
            transaction,
        });
        

        

        

        return activity_comments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const activity_commentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                visibility: item.visibility
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                posted_at: item.posted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const activity_comments = await db.activity_comments.bulkCreate(activity_commentsData, { transaction });

        // For each item created, replace relation files
        

        return activity_comments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const activity_comments = await db.activity_comments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.visibility !== undefined) updatePayload.visibility = data.visibility;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.posted_at !== undefined) updatePayload.posted_at = data.posted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await activity_comments.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await activity_comments.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organization !== undefined) {
            await activity_comments.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await activity_comments.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.booking_request !== undefined) {
            await activity_comments.setBooking_request(
              
              data.booking_request,
              
              { transaction }
            );
        }
        
        if (data.reservation !== undefined) {
            await activity_comments.setReservation(
              
              data.reservation,
              
              { transaction }
            );
        }
        
        if (data.service_request !== undefined) {
            await activity_comments.setService_request(
              
              data.service_request,
              
              { transaction }
            );
        }
        
        if (data.invoice !== undefined) {
            await activity_comments.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        

        
        

        

        return activity_comments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const activity_comments = await db.activity_comments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of activity_comments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of activity_comments) {
                await record.destroy({transaction});
            }
        });


        return activity_comments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const activity_comments = await db.activity_comments.findByPk(id, options);

        await activity_comments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await activity_comments.destroy({
            transaction
        });

        return activity_comments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const activity_comments = await db.activity_comments.findOne(
            { where },
            { transaction },
        );

        if (!activity_comments) {
            return activity_comments;
        }

        const output = activity_comments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await activity_comments.getTenant({
            transaction
        });
        
        
        output.organization = await activity_comments.getOrganization({
            transaction
        });
        
        
        output.author = await activity_comments.getAuthor({
            transaction
        });
        
        
        output.booking_request = await activity_comments.getBooking_request({
            transaction
        });
        
        
        output.reservation = await activity_comments.getReservation({
            transaction
        });
        
        
        output.service_request = await activity_comments.getService_request({
            transaction
        });
        
        
        output.invoice = await activity_comments.getInvoice({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.booking_requests,
        as: 'booking_request',
        
        where: filter.booking_request ? {
          [Op.or]: [
            { id: { [Op.in]: filter.booking_request.split('|').map(term => Utils.uuid(term)) } },
            {
              request_code: {
                [Op.or]: filter.booking_request.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.reservations,
        as: 'reservation',
        
        where: filter.reservation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reservation.split('|').map(term => Utils.uuid(term)) } },
            {
              reservation_code: {
                [Op.or]: filter.reservation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.service_requests,
        as: 'service_request',
        
        where: filter.service_request ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_request.split('|').map(term => Utils.uuid(term)) } },
            {
              summary: {
                [Op.or]: filter.service_request.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_number: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'activity_comments',
                        'body',
                        filter.body,
                    ),
                };
            }
            

            
            

            
            if (filter.posted_atRange) {
                const [start, end] = filter.posted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.visibility) {
                where = {
                    ...where,
                visibility: filter.visibility,
            };
            }
            


      

      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.activity_comments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'activity_comments',
                        'body',
                        query,
                    ),
                ],
            };
        }

        const records = await db.activity_comments.findAll({
            attributes: [ 'id', 'body' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['body', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.body,
        }));
    }

    
};

